/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.internet.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="INTERNET_WIDGET.InternetSeiteMaxZeile",
     query="SELECT MAX(o.zeile) FROM InternetWidget o WHERE o.internetSeite = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="INTERNET_WIDGET.InternetSeiteOhneHeaderOrdered",
     query="SELECT o FROM InternetWidget o WHERE o.internetSeite = ?1 AND o.zeile>= 1 ORDER BY o.zeile, o.position",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="INTERNET_WIDGET.InternetSeiteOrdered",
     query="SELECT o FROM InternetWidget o WHERE o.internetSeite = ?1 ORDER BY o.zeile, o.position",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "INTERNET_WIDGET")
// @javax.persistence.IdClass(InternetWidgetPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class InternetWidget
extends AbstractInternetWidget
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected InternetWidget() {
    super();
  }
    public InternetWidget(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public InternetWidget(InternetWidget original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "internet_widget_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "InternetWidget")
    @javax.persistence.TableGenerator(name = "InternetWidget", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "InternetWidget", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient InternetWidgetPK pkCache;

  @Override
  public InternetWidgetPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new InternetWidgetPK(getId());
    }

    return pkCache;
  }

  public static <E extends InternetWidget> java.util.Map<InternetWidgetPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<InternetWidgetPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends InternetWidget> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBeschreibung = false;
          hasChangedBreite = false;
          hasChangedIdentifier = false;
          hasChangedPosition = false;
          hasChangedSprungmarke = false;
          hasChangedStatus = false;
          hasChangedWidgetTyp = false;
          hasChangedZeile = false;
  
      hasChangedCustomDataStorage = false;
    


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = InternetWidgetConstants.BESCHREIBUNG_NULLABLE, length=InternetWidgetConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, InternetWidgetConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "BREITE", nullable = InternetWidgetConstants.BREITE_NULLABLE)
    
  protected de.ivu.elect.business.internet.entity.InternetWidgetBreite breite =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBreite = false;

  public boolean hasChangedBreite(){
    return hasChangedBreite;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBreite = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.internet.entity.InternetWidgetBreite wertNachLadenBreite;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.BREITE
   */
    @Override   public  de.ivu.elect.business.internet.entity.InternetWidgetBreite getBreite() {
        return breite;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.BREITE
   *
   * @param breite
   */
  @Override   public void setBreite( de.ivu.elect.business.internet.entity.InternetWidgetBreite breite) {

       resetTkCache();
                  de.ivu.elect.business.internet.entity.InternetWidgetBreite breiteInternal = breite;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.breite
      , breiteInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBreite |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("breite");
      }


             if (!isSeitLadenVeraendertBreite) {
          isSeitLadenVeraendertBreite = thisAttributChanged;
         if (isSeitLadenVeraendertBreite){
           wertNachLadenBreite=this.breite;
         }
       }
      

       this.breite = breiteInternal;

         }

        
  @javax.persistence.Column(name = "IDENTIFIER", nullable = InternetWidgetConstants.IDENTIFIER_NULLABLE, length=InternetWidgetConstants.IDENTIFIER_MAX_LENGTH)
        
  protected java.lang.String identifier =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIdentifier = false;

  public boolean hasChangedIdentifier(){
    return hasChangedIdentifier;
  }
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.IDENTIFIER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIdentifier() {
        return identifier;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.IDENTIFIER
   *
   * @param identifier
   */
  @Override   public void setIdentifier(@javax.annotation.Nullable  java.lang.String identifier) {

       resetTkCache();
                  
                          java.lang.String identifierInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(identifier, InternetWidgetConstants.IDENTIFIER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.identifier
      , identifierInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIdentifier |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("identifier");
      }


      

       this.identifier = identifierInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = InternetWidgetConstants.POSITION_NULLABLE, precision=InternetWidgetConstants.POSITION_PRECISION, scale=InternetWidgetConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPosition = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenPosition;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


             if (!isSeitLadenVeraendertPosition) {
          isSeitLadenVeraendertPosition = thisAttributChanged;
         if (isSeitLadenVeraendertPosition){
           wertNachLadenPosition=this.position;
         }
       }
      

       this.position = positionInternal;

         }

        
  @javax.persistence.Column(name = "SPRUNGMARKE", nullable = InternetWidgetConstants.SPRUNGMARKE_NULLABLE, length=InternetWidgetConstants.SPRUNGMARKE_MAX_LENGTH)
        
  protected java.lang.String sprungmarke =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSprungmarke = false;

  public boolean hasChangedSprungmarke(){
    return hasChangedSprungmarke;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSprungmarke = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSprungmarke;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.SPRUNGMARKE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getSprungmarke() {
        return sprungmarke;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.SPRUNGMARKE
   *
   * @param sprungmarke
   */
  @Override   public void setSprungmarke(@javax.annotation.Nullable  java.lang.String sprungmarke) {

       resetTkCache();
                  
                          java.lang.String sprungmarkeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(sprungmarke, InternetWidgetConstants.SPRUNGMARKE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.sprungmarke
      , sprungmarkeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSprungmarke |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("sprungmarke");
      }


             if (!isSeitLadenVeraendertSprungmarke) {
          isSeitLadenVeraendertSprungmarke = thisAttributChanged;
         if (isSeitLadenVeraendertSprungmarke){
           wertNachLadenSprungmarke=this.sprungmarke;
         }
       }
      

       this.sprungmarke = sprungmarkeInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = InternetWidgetConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.internet.entity.InternetWidgetStatus status =  de.ivu.elect.business.internet.entity.InternetWidgetStatus.AKTIV;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.internet.entity.InternetWidgetStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.STATUS
   */
    @Override   public  de.ivu.elect.business.internet.entity.InternetWidgetStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.internet.entity.InternetWidgetStatus status) {

       resetTkCache();
                  de.ivu.elect.business.internet.entity.InternetWidgetStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WIDGET_TYP", nullable = InternetWidgetConstants.WIDGET_TYP_NULLABLE)
    
  protected de.ivu.elect.business.internet.entity.InternetWidgetTyp widgetTyp =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWidgetTyp = false;

  public boolean hasChangedWidgetTyp(){
    return hasChangedWidgetTyp;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWidgetTyp = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.internet.entity.InternetWidgetTyp wertNachLadenWidgetTyp;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.WIDGET_TYP
   */
    @Override   public  de.ivu.elect.business.internet.entity.InternetWidgetTyp getWidgetTyp() {
        return widgetTyp;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.WIDGET_TYP
   *
   * @param widgetTyp
   */
  @Override   public void setWidgetTyp( de.ivu.elect.business.internet.entity.InternetWidgetTyp widgetTyp) {

       resetTkCache();
                  de.ivu.elect.business.internet.entity.InternetWidgetTyp widgetTypInternal = widgetTyp;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.widgetTyp
      , widgetTypInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWidgetTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("widgetTyp");
      }


             if (!isSeitLadenVeraendertWidgetTyp) {
          isSeitLadenVeraendertWidgetTyp = thisAttributChanged;
         if (isSeitLadenVeraendertWidgetTyp){
           wertNachLadenWidgetTyp=this.widgetTyp;
         }
       }
      

       this.widgetTyp = widgetTypInternal;

         }

        
      @javax.persistence.Column(name = "ZEILE", nullable = InternetWidgetConstants.ZEILE_NULLABLE, precision=InternetWidgetConstants.ZEILE_PRECISION, scale=InternetWidgetConstants.ZEILE_SCALE)
            
  protected java.lang.Long zeile =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeile = false;

  public boolean hasChangedZeile(){
    return hasChangedZeile;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeile = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenZeile;
  
  /**
   * 
   *
   * getter for INTERNET_WIDGET.ZEILE
   */
    @Override   public  java.lang.Long getZeile() {
        return zeile;
      }

  /**
   * 
   *
   * setter for INTERNET_WIDGET.ZEILE
   *
   * @param zeile
   */
  @Override   public void setZeile( java.lang.Long zeile) {

       resetTkCache();
                  java.lang.Long zeileInternal = zeile;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeile
      , zeileInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeile |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeile");
      }


             if (!isSeitLadenVeraendertZeile) {
          isSeitLadenVeraendertZeile = thisAttributChanged;
         if (isSeitLadenVeraendertZeile){
           wertNachLadenZeile=this.zeile;
         }
       }
      

       this.zeile = zeileInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }


/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu InternetSeite
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "INTERNET_SEITE_ID", referencedColumnName="INTERNET_SEITE_ID"))
  protected de.ivu.elect.business.internet.entity.InternetSeite internetSeite;

  /**
   * 
   */
  @Override
  public void setInternetSeite( de.ivu.elect.business.internet.entity.InternetSeite internetSeite){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (internetSeite == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.internetSeite != null){
            this.internetSeite.removeInternetWidgetByInternetSeite(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          internetSeite.addInternetWidgetByInternetSeite(this);
        }
        this.internetSeite = internetSeite;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setInternetSeiteOhneUpdateBeziehung( de.ivu.elect.business.internet.entity.InternetSeite internetSeite){
    resetTkCache();
        this.internetSeite = internetSeite;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.internet.entity.InternetSeite getInternetSeite(){
    return this.internetSeite;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("InternetWidget:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(InternetWidget other){
                             other.beschreibung = this.beschreibung;
                                other.breite = this.breite;
                                other.identifier = this.identifier;
                                other.position = this.position;
                                other.sprungmarke = this.sprungmarke;
                                other.status = this.status;
                                other.widgetTyp = this.widgetTyp;
                                other.zeile = this.zeile;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setInternetSeite(this.getInternetSeite());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(InternetWidget.class)){
        copyEntityAttributesUsingSetter((InternetWidget) other.castTo(InternetWidget.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von InternetWidget: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(InternetWidget other){
               other.setBeschreibung(this.beschreibung);
                  other.setBreite(this.breite);
                  other.setIdentifier(this.identifier);
                  other.setPosition(this.position);
                  other.setSprungmarke(this.sprungmarke);
                  other.setStatus(this.status);
                  other.setWidgetTyp(this.widgetTyp);
                  other.setZeile(this.zeile);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(InternetWidget other){
                       if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedBreite) {
        other.setBreite(this.breite);
      }
                             if (hasChangedIdentifier) {
        other.setIdentifier(this.identifier);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
                             if (hasChangedSprungmarke) {
        other.setSprungmarke(this.sprungmarke);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedWidgetTyp) {
        other.setWidgetTyp(this.widgetTyp);
      }
                             if (hasChangedZeile) {
        other.setZeile(this.zeile);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität InternetWidget besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität InternetWidget hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität InternetWidget hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität InternetWidget hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität InternetWidget hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient InternetWidgetTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public InternetWidgetTK getInternetWidgetTK(){
    if (tkCache==null) {
    tkCache = new InternetWidgetTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getInternetWidgetTK();
    }

  @Override
  public InternetWidgetUK getUk(){
    return getInternetWidgetUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return InternetWidget.class;
  }

public InternetWidgetUK getInternetWidgetUK(){

   return  new InternetWidgetUK(



  );
}

  @javax.persistence.Transient
  private transient InternetWidgetProperties properties;

  public InternetWidgetProperties getProperties(){
    if (properties == null) {
      properties = new InternetWidgetProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public InternetWidgetProperties getInternetWidgetProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return InternetWidgetConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_BREITE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_BREITE_EINZAHL);

        breite =
     (de.ivu.elect.business.internet.entity.InternetWidgetBreite) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_POSITION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_POSITION_EINZAHL);

        position =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_SPRUNGMARKE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_SPRUNGMARKE_EINZAHL);

        sprungmarke =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.internet.entity.InternetWidgetStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_WIDGET_TYP_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_WIDGET_TYP_EINZAHL);

        widgetTyp =
     (de.ivu.elect.business.internet.entity.InternetWidgetTyp) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(InternetWidgetConstants.MESSAGE_KEY_ZEILE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(InternetWidgetConstants.MESSAGE_KEY_ZEILE_EINZAHL);

        zeile =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBeschreibung) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                            if (isSeitLadenVeraendertBreite) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_BREITE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenBreite , breite));
    }
                                                if (isSeitLadenVeraendertPosition) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_POSITION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenPosition , position));
    }
                            if (isSeitLadenVeraendertSprungmarke) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_SPRUNGMARKE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSprungmarke , sprungmarke));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertWidgetTyp) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_WIDGET_TYP_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWidgetTyp , widgetTyp));
    }
                            if (isSeitLadenVeraendertZeile) {
      result.put(InternetWidgetConstants.MESSAGE_KEY_ZEILE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenZeile , zeile));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                          isSeitLadenVeraendertBreite = false;
      wertNachLadenBreite = null;
                                          isSeitLadenVeraendertPosition = false;
      wertNachLadenPosition = null;
                          isSeitLadenVeraendertSprungmarke = false;
      wertNachLadenSprungmarke = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertWidgetTyp = false;
      wertNachLadenWidgetTyp = null;
                          isSeitLadenVeraendertZeile = false;
      wertNachLadenZeile = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "INTERNET_WIDGET";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "InternetWidget";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(InternetWidgetConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, InternetWidgetConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(breite, this, InternetWidgetConstants.MESSAGE_KEY_BREITE_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(InternetWidgetConstants.IDENTIFIER_MAX_LENGTH ,  identifier, this, InternetWidgetConstants.MESSAGE_KEY_IDENTIFIER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, InternetWidgetConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(InternetWidgetConstants.POSITION_MAX_VALUE, InternetWidgetConstants.POSITION_MIN_VALUE, position, this, InternetWidgetConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(InternetWidgetConstants.SPRUNGMARKE_MAX_LENGTH ,  sprungmarke, this, InternetWidgetConstants.MESSAGE_KEY_SPRUNGMARKE_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, InternetWidgetConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(widgetTyp, this, InternetWidgetConstants.MESSAGE_KEY_WIDGET_TYP_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeile, this, InternetWidgetConstants.MESSAGE_KEY_ZEILE_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(InternetWidgetConstants.ZEILE_MAX_VALUE, InternetWidgetConstants.ZEILE_MIN_VALUE, zeile, this, InternetWidgetConstants.MESSAGE_KEY_ZEILE_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
